//
//            ̼(BSC)Ա
//            Baby Fox Simple Class
//
//    ̱ȨʹȨг򰮺
//
//                class FAngle, FPlane
//

#ifndef _FPlane_Appeared_
#define _FPlane_Appeared_

#include <math.h>

const double pi=3.14159265358979;

struct point
{
    int x;
    int y;

    point(int X=0, int Y=0){x=X; y=Y;}
    point(point &other){operator =(other);}

    point &operator =(point &other){x=other.x; y=other.y; return *this;}
};

struct basis
{
    double x;
    double y;

    basis(double X=0.0, double Y=0.0){x=X; y=Y;}
    basis(basis &other){operator =(other);}

    basis &operator =(basis &other){x=other.x; y=other.y; return *this;}
};

/*

Լ
    ԽǶϵˮƽΪ0˳ʱ뷽Ϊ
    νǶϵˮƽΪ0ʱ뷽Ϊ
    ʱӽǶϵֱΪ0˳ʱ뷽Ϊ

    Ƕȣ涨ܽΪ360
    ȣ涨ܽΪ2л
    ݶȣ涨ܽΪ400

*/

enum AngleMode{Angle_Absolute, Angle_Geometry, Angle_Clock};
enum AngleUnit{Angle_Degree, Angle_Radian, Angle_Grads};

class FAngle
{
//˽
protected:
    //ԽǶϵ
    double angle;

public:
//
    //Ƚ
    static double delta;

//ϵͳú벻Ҫע

    //ȱʡ캯
    FAngle(double Angle=0.0){setAngle(Angle, Angle_Geometry);}
    //캯
    FAngle(FAngle &other){operator =(other);}
    //
    virtual ~FAngle(){;}

//
    operator double(){return getAngle();}

    FAngle &operator =(double Angle);
    FAngle &operator =(FAngle &other){return operator =(other.getAngle());}

    FAngle operator +(double number){return FAngle(getAngle()+number);}
    FAngle operator +(FAngle &other){return operator +(other.getAngle());}
    FAngle operator -(double number){return FAngle(getAngle()-number);}
    FAngle operator -(FAngle &other){return operator -(other.getAngle());}
    FAngle operator -(){return FAngle(-getAngle());}
    FAngle operator *(double number){return FAngle(getAngle()*number);}
    FAngle operator /(double number){return FAngle(getAngle()/number);}
    FAngle &operator +=(double number);
    FAngle &operator +=(FAngle &other){return operator +=(other.getAngle());}
    FAngle &operator -=(double number);
    FAngle &operator -=(FAngle &other){return operator -=(other.getAngle());}
    FAngle &operator *=(double number);
    FAngle &operator /=(double number);

    bool operator >(double number){return operator >(FAngle(number));}
    bool operator >(FAngle &other){return getAngle()>other.getAngle();}
    bool operator <(double number){return operator <(FAngle(number));}
    bool operator <(FAngle &other){return getAngle()<other.getAngle();}
    bool operator >=(double number){return operator >=(FAngle(number));}
    bool operator >=(FAngle &other){return !operator <(other);}
    bool operator <=(double number){return operator <=(FAngle(number));}
    bool operator <=(FAngle &other){return !operator >(other);}
    bool operator ==(double number){return operator ==(FAngle(number));}
    bool operator ==(FAngle &other){return getAngle()>other.getAngle()-delta&&getAngle()<other.getAngle()+delta;;}
    bool operator !=(double number){return operator !=(FAngle(number));}
    bool operator !=(FAngle &other){return !operator ==(other);}

//ûⲿ

    //ȡǶ
    double getAngle(AngleMode Mode=Angle_Geometry, AngleUnit Unit=Angle_Radian);
    //ýǶ
    double setAngle(double Angle, AngleMode Mode=Angle_Geometry, AngleUnit Unit=Angle_Radian);
};

//¸ǽӿڵľʵ֣ûбҪ˽ǵ
//ֻҪгĽӿڲʹǾ
//ĻǾ

//

FAngle &FAngle::operator =(double Angle)
{
    setAngle(Angle);
    return *this;
}

FAngle &FAngle::operator +=(double number)
{
    FAngle temp(getAngle()+number);
    angle=temp.angle;
    return *this;
}

FAngle &FAngle::operator -=(double number)
{
    FAngle temp(getAngle()-number);
    angle=temp.angle;
    return *this;
}

FAngle &FAngle::operator *=(double number)
{
    FAngle temp(getAngle()*number);
    angle=temp.angle;
    return *this;
}

FAngle &FAngle::operator /=(double number)
{
    FAngle temp(getAngle()/number);
    angle=temp.angle;
    return *this;
}

double FAngle::getAngle(AngleMode Mode, AngleUnit Unit)
{
    double temp=angle;

    switch(Mode)
    {
    case Angle_Geometry:
        if(temp!=0)temp=2*pi-temp;
        break;
    case Angle_Clock:
        temp+=pi/2;
        if(temp>2*pi)
            temp-=2*pi;
    }

    switch(Unit)
    {
    case Angle_Degree:
        temp*=180/pi;
        break;
    case Angle_Grads:
        temp*=200/pi;
    }

    return temp;
}

double FAngle::setAngle(double Angle, AngleMode Mode, AngleUnit Unit)
{
    switch(Unit)
    {
    case Angle_Degree:
        Angle*=pi/180;
        break;
    case Angle_Grads:
        Angle*=pi/200;
    }

    switch(Mode)
    {
    case Angle_Geometry:
        if(Angle!=0)Angle=2*pi-Angle;
        break;
    case Angle_Clock:
        Angle-=pi/2;
        if(Angle<0)
            Angle+=2*pi;
    }

    return angle=Angle;
}

class FPlane
{
//˽ݺ˽к
protected:
    //ֱx
    double x;
    //ֱy
    double y;
    //
    double rho;
    //
    FAngle theta;

    //xӳƫ
    int offsetX;
    //yӳƫ
    int offsetY;

    //xӳ
    basis basisX;
    //yӳ
    basis basisY;

    //¼ֱ
    void CalculateRightAngle();
    //¼㼫
    void CalculatePolar();

public:
//
    //Ƚ
    static double delta;

//ϵͳú벻Ҫע

    //ȱʡ캯
    FPlane(double X=0, double Y=0, int OffsetX=100, int OffsetY=100, basis BasisX=basis(1, 0), basis BasisY=basis(0, 1));
    //캯
    FPlane(FPlane &other){operator =(other);}
    //
    virtual ~FPlane(){;}

//
    virtual FPlane &operator =(FPlane &other);

    virtual FPlane operator +(FPlane &other);
    virtual FPlane operator -(FPlane &other);
    virtual FPlane operator -();
    virtual FPlane operator *(double number);
    virtual FPlane operator /(double number);
    virtual FPlane &operator +=(FPlane &other);
    virtual FPlane &operator -=(FPlane &other);
    virtual FPlane &operator *=(double number);
    virtual FPlane &operator /=(double number);

    virtual bool operator >(double number){return rho>number;}
    virtual bool operator >(FPlane &other){return operator >(other.rho);}
    virtual bool operator <(double number){return rho<number;}
    virtual bool operator <(FPlane &other){return operator <(other.rho);}
    virtual bool operator >=(double number){return !operator <(number);}
    virtual bool operator >=(FPlane &other){return operator >=(other.rho);}
    virtual bool operator <=(double number){return !operator >(number);}
    virtual bool operator <=(FPlane &other){return operator <=(other.rho);}
    virtual bool operator ==(double number){return rho>number-delta&&rho<number+delta;}
    virtual bool operator ==(FPlane &other){return x>other.x-delta&&x<other.x-delta&&y>other.y-delta&&y<other.y-delta;}
    virtual bool operator !=(double number){return !operator ==(number);}
    virtual bool operator !=(FPlane &other){return !operator ==(other);}

//ûⲿ

    //ȡx
    double getX(){return x;}
    //x
    double setX(double X){x=X; CalculatePolar(); return X;}
    //ȡy
    double getY(){return y;}
    //y
    double setY(double Y){y=Y; CalculatePolar(); return Y;}

    //ȡ
    double getRho(){return rho;}
    //æ
    double setRho(double Rho){rho=Rho; CalculateRightAngle(); return rho;}
    //ȡ
    FAngle getTheta(){return theta;}
    //æ
    FAngle setTheta(double Theta, AngleMode Mode=Angle_Geometry, AngleUnit Unit=Angle_Radian);
    //æ
    FAngle setTheta(FAngle &Theta){return setTheta(Theta.getAngle());}

    //ȡxӳ
    basis &BasisX(){return basisX;}
    //ȡyӳ
    basis &BasisY(){return basisY;}
    //ȡxӳƫ
    int &OffsetX(){return offsetX;}
    //ȡyӳƫ
    int &OffsetY(){return offsetY;}

    //ӳΪĻ
    virtual void Project(int &X, int &Y);
    //ӳΪĻ
    virtual point Project(void);
    //Ļӳϵ
    FPlane &Unproject(int x, int y);
    //Ļӳϵ
    FPlane &Unproject(point &Point);
};

//¸ǽӿڵľʵ֣ûбҪ˽ǵ
//ֻҪгĽӿڲʹǾ
//ĻǾ

//˽к

void FPlane::CalculateRightAngle()
{
    x=rho*cos(theta.getAngle());
    y=rho*sin(theta.getAngle());
}

void FPlane::CalculatePolar()
{
    rho=sqrt(x*x+y*y);
    if(rho==0)
        theta=0;
    else
    {
        theta=acos(x/rho);
        if(y<0)
            theta=2*pi-theta;
    }
}

//ϵͳú

FPlane::FPlane(double X, double Y, int OffsetX, int OffsetY, basis BasisX, basis BasisY)
{
    x=X;
    y=Y;

    CalculatePolar();

    offsetX=OffsetX;
    offsetY=OffsetY;

    basisX=BasisX;
    basisY=BasisY;
}

//

FPlane &FPlane::operator =(FPlane &other)
{
    x=other.x;
    y=other.y;

    rho=other.rho;
    theta=other.theta;

    basisX=other.basisX;
    basisY=other.basisY;

    offsetX=other.offsetX;
    offsetY=other.offsetY;

    return *this;
}

FPlane FPlane::operator +(FPlane &other)
{
    FPlane temp(*this);
    temp+=other;
    return temp;
}

FPlane FPlane::operator -(FPlane &other)
{
    FPlane temp(*this);
    temp-=other;
    return temp;
}

FPlane FPlane::operator -()
{
    FPlane temp(*this);
    temp.x=-x;
    temp.y=-y;
    temp.CalculatePolar();
    return temp;
}

FPlane FPlane::operator *(double number)
{
    FPlane temp(*this);
    temp*=number;
    return temp;
}

FPlane FPlane::operator /(double number)
{
    FPlane temp(*this);
    temp/=number;
    return temp;
}

FPlane &FPlane::operator +=(FPlane &other)
{
    x+=other.x;
    y+=other.y;
    CalculatePolar();
    return *this;
}

FPlane &FPlane::operator -=(FPlane &other)
{
    x-=other.x;
    y-=other.y;
    CalculatePolar();
    return *this;
}

FPlane &FPlane::operator *=(double number)
{
    rho*=number;
    CalculateRightAngle();
    return *this;
}

FPlane &FPlane::operator /=(double number)
{
    rho/=number;
    CalculateRightAngle();
    return *this;
}

//ûӿڷ

FAngle FPlane::setTheta(double Theta, AngleMode Mode, AngleUnit Unit)
{
    theta.setAngle(Theta, Mode, Unit);
    CalculateRightAngle();
    return theta;
}

void FPlane::Project(int &X, int &Y)
{
    X=(int)(x*basisX.x+y*basisY.x)+offsetX;
    Y=offsetY-(int)(x*basisX.y+y*basisY.y);
}

point FPlane::Project(void)
{
    int x, y;

    point temp;
    Project(x, y);
    temp.x=x;
    temp.y=y;

    return temp;
}

FPlane &FPlane::Unproject(int X, int Y)
{
    double asterisk=basisX.x*basisY.y-basisY.x*basisX.y;
    if(asterisk>-delta&&asterisk<delta)
        return *this;

    x=(X*basisY.y-Y*basisX.y)/asterisk-offsetX;
    y=offsetY-(-X*basisY.x+Y*basisX.x)/asterisk;

    CalculatePolar();
    return *this;
}

FPlane &FPlane::Unproject(point &Point)
{
    return Unproject(Point.x, Point.y);
}

double FAngle::delta=0.000001;
double FPlane::delta=0.000001;

#endif
